-- GOLDTRACKER
-- By Soap of Shadow Council Horde - US
-- please visit http://wow-ratings.com if you wish to donate
--
-- COMMAND LIST:
-- /gt or /goldtracker to see help
-- 
-- HISTORY:
-- v1.0 - simple /party calls to gather information
-- v1.1 - moved all communication from /party to addon chat
-- v1.2 - added the information for all toons visited, online or not
--

  version = "1.2";

  -- text strings  
  chatRequest 		= "GoldTracker: Gathering Info...";
  chatGotRequest 	= "GoldTracker: Received request from ";
  chatDoneRequest 	= "GoldTracker: Finished";
  chatAnswer  		= "GoldTracker: Sending Data for ";
  chatSummary 		= "GoldTracker: Total is ";
  chatEOF 			= "GoldTracker: End Of File";
  chatLoaded  		= "GoldTracker by Soap of ShadowCouncil US - v"..version.." loaded.";
  chatLoaded2		= "use [ /gt help ] for more info";
  chatHelp1			= "/gt (or /goldtracker): List the gold of all known characters of the grouped players";
  chatHelp2			= "/gt silent: Only give the total gold (the total is still based on all known toons)";
  chatHelp3			= "/gt current: Only list the toons in the party (the total is still based on all known toons)";
  

  sumCopper = 0;
  count = 0;
  master = false;
    
  frame = CreateFrame("FRAME", "GoldTrackerFrame");
  frame:RegisterEvent("ADDON_LOADED");
  frame:RegisterEvent("CHAT_MSG_ADDON");
  frame:RegisterEvent("PLAYER_MONEY");
  frame:RegisterEvent("PLAYER_ENTERING_WORLD");
  

----------------------------------------------------------

  function GT_OnSlashCommand(msg)
    
    silent=false;
    current=false;
    
    if msg == 'silent' then	
    	silent = true;    
    end

    if msg == 'current' then
    	current = true;
    end
  
    if msg == 'help' then
    	print(chatLoaded);
    	print(chatHelp1);
    	print(chatHelp2);
    	print(chatHelp3);
    else
    	SendAddonMessage("GoldTracker", chatRequest ,"PARTY");
    	print(chatRequest);
    	sumCopper = 0;
    	count = 0;
    	master = true;
    	dataReady = false;
	end   
  end

  
  ----------------------------------------------------------
  
  
  function frame:OnEvent(event, ...)

      -- retrieve data for other toons from saved variable.  	  
  	  if event == "ADDON_LOADED" and arg1 == "GoldTracker" then 
  	    if GoldTracker_Data == nil then 
  	    	GoldTracker_Data = {};
  	    end
  	  	if GoldTracker_Data[GetRealmName()] == nil then 
	  		GoldTracker_Data[GetRealmName()] = {};
  	  	end
  	  	print(chatLoaded);
  	  	print(chatLoaded2);
  	  end


  	  if event == "PLAYER_ENTERING_WORLD" then 
		GoldTracker_Data[GetRealmName()][UnitName("player")] = GetMoney();
	  end



  	  
  	  if event == "CHAT_MSG_ADDON" and arg1 == "GoldTracker" then
   	  	--print("RECEIVED"..arg2.." / "..arg3.." / "..arg4);
   	  	
  	  	-- receive request / give answer
  	    if arg2 == chatRequest then
  	    	
  	    	-- only display the request on 'other' toons
  			if arg4 ~= UnitName("player") then
  				print(chatGotRequest..arg4);
  			end
  			
  			curData = GoldTracker_Data[GetRealmName()];
  			
  			-- loop through all saved toons on this realm
  			for i, v in pairs(curData) do
  			  	if arg4 ~= UnitName("player") then
  					print(chatAnswer..string.upper(i).." : "..formatGold(v));
  				end
  				SendAddonMessage("GoldTracker", chatAnswer..i.." : "..v, "WHISPER", arg4);
  			end
  			SendAddonMessage("GoldTracker", chatEOF, "WHISPER", arg4);
  			if arg4 ~= UnitName("player") then
  				print(chatDoneRequest);
  			end

  			
	    end



		--only the toon that requested (the master) should calculate total
		if master then
		
			-- receive answers / compute total 
			toon, copper = string.match (arg2, chatAnswer.."(.*) : (.*)$");
	
	  	    if toon ~= nil and copper ~= nil then
	  	    
	  	    	if silent == false then
	  	    		if current == false or string.upper(arg4) == string.upper(toon) then
	  	    			print("From "..string.upper(arg4)..":"..string.upper(toon).." has "..formatGold(copper));
	  	    		end
	  	    	end
	 	    	sumCopper = sumCopper + copper;
				
		    end
		    
		    
		    
		    -- wait for all / give total 	  	
		    if arg2 == chatEOF then
		    	count = count +1;
				if count > GetNumPartyMembers() then
					dataReady = true
				end
				
				if dataReady then
					print("========================================");
					print(chatSummary..formatGold(sumCopper));
					print("========================================");					
					if silent==false and current==false then 
					  print(chatLoaded2);
					end
					master = false;
					dataReady=false;
		  	    end
		    	
		    end
		    
		    
		 end	    
  	  end
  	  
  	  
  	  
  	  --update data whenever money changes
  	  if event == "PLAYER_MONEY" then
  	  	  GoldTracker_Data[GetRealmName()][UnitName("player")] = GetMoney();
  	  end
  	  
  end

  ----------------------------------------------------------
  
  function formatGold(copper) 
  	silver = math.floor(copper/100);
  	copper = copper - silver*100;
  	
  	gold = math.floor(silver/100);
  	silver = silver - gold*100;
  	
  	return gold.."g "..silver.."s "..copper.."c";
  end 

  ----------------------------------------------------------

  frame:SetScript("OnEvent", frame.OnEvent);  
  SLASH_GOLDTRACKER1 = "/gt"
  SLASH_GOLDTRACKER2 = "/goldtracker"
  SlashCmdList["GOLDTRACKER"] = GT_OnSlashCommand
    